
 void Init_ADC()  // for 18F45K22
 {
  //config lecture ADC 10 bits
  ADCON0.CHS3=0;   // channel 0  selected
  ADCON0.CHS2=0;
  ADCON0.CHS1=0;
  ADCON0.CHS0=0;
   // REGISTER 21-2: ADCON1: A/D CONTROL REGISTER 1   page 302
  ADCON1=0;
  ADCON1.PVCFG1=0; // +VREF= VDD=+5V
  ADCON1.PVCFG0=0;
  ADCON1.NVCFG1=0;  // -VREF= VSS 0V
  ADCON1.NVCFG0=0;
  ADCON2=0;
  ADCON2.ADFM=1;  // Right justified
  // ACQUistion Time(TAD)  110=> 16 TAD
  ADCON2.ACQT2=1;
  ADCON2.ACQT1=1;
  ADCON2.ACQT0=0;
  // CONVERSIO CLOCK PERIOD  110 => Fosc/64
  ADCON2.ADCS1=1;
  ADCON2.ADCS2=1;
  ADCON2.ADCS0=0;
  ADCON0.ADON=1;    // ADC enabled
 }
 
 unsigned int Read_ADC(unsigned char Canal)  // for 18F45K22
{   unsigned int Ex;
    if (Canal > 7) return 0;
    ADCON0 |= Canal <<2;
    Delay_ms(5);
    ADCON0.GO_DONE = 1;//Start A/D Conversion
    _asm NOP ;
    while(ADCON0.GO_DONE ==1);//Loop here until A/D conversion completes
    Ex=(ADRESH <<8) + ADRESL;
    return Ex;
 }

  /* exemple of use
  Init_ADC();   // was ADC_Init();
  UART1_Write_CText(" 1ere Lecture ADC RA1 \r\n");
  EA1=Read_ADCx(1);   // was ADC_Read(1);
  WordToStr(EA1,txt);
  UART1_Write_Text(txt);
  UART1_Write(TAB);
  */